diff -Naur inkscape2/src/extension/internal/javafx-out.cpp inkscape/src/extension/internal/javafx-out.cpp
--- inkscape2/src/extension/internal/javafx-out.cpp	2009-02-12 10:39:35.000000000 +0100
+++ inkscape/src/extension/internal/javafx-out.cpp	2009-02-10 10:35:03.000000000 +0100
@@ -593,208 +755,185 @@
     return true;
 }
 
+bool JavaFXOutput::doImage(SPImage *image, const Glib::ustring &id)
+{
+    out("    /** image %s */\n", id.c_str());
+    out("    function %s() : ImageView {\n", id.c_str());
+    out("        ImageView {\n");
+
+    out("            x: %s, y: %s\n",
+        sp_object_getAttribute(image, "x", NULL), sp_object_getAttribute(image, "y", NULL));
+    out("            fitWidth: %s, fitHeight: %s\n",
+        sp_object_getAttribute(image, "width", NULL), sp_object_getAttribute(image, "height", NULL));
+
+    char const *data_string = "data:image/";
+    char const *url_string = sp_object_getAttribute(image, "xlink:href", NULL);
+    if (strncmp(url_string, data_string, strlen(data_string)) == 0) {
+        char message[256];
+        sprintf(message,"No support for embedded image '%s' in JavaFX 1.0 ('null' image substituted)\n"
+			"Hint: use \"Effects->Images->Extract One Image...\" first!", id.c_str());
+        sp_ui_error_dialog(message);
+        out("            image: Image {url: null}\n");
+    }
+    else
+        out("            image: Image {url: \"{__DIR__}%s\"}\n", sp_object_getAttribute(image, "xlink:href", NULL));
 
+    Geom::Matrix const tm(sp_item_i2doc_affine(image)); // <- _c[0],_c[1],_c[2],_c[3],_c[4],_c[5]
+    if ( !tm.isIdentity() ) {
+        Geom::Point pX = tm.xAxis();          // <- _c[0], _c[1]
+        Geom::Point pY = tm.yAxis();          // <- _c[2], _c[3]
+        Geom::Point pZ = tm.translation();    // <- _c[4], _c[5]
+        out("            transforms : Transform.affine(%.3f,%.3f,%.3f,%.3f,%.3f,%.3f)\n",
+                 pX[0],pX[1],pY[0],pY[1],pZ[0],pZ[1]);
+    }
 
-#else
+    out("        };\n    }\n\n");
+    return true;
+}
 
-/**
- *  Output the curve data to buffer
- */
-bool JavaFXOutput::doCurve(SPItem *item, const String &id)
+bool JavaFXOutput::doText(SPText *text, const Glib::ustring &id)
 {
-    using Geom::X;
-    using Geom::Y;
-
-    //### Get the Shape
-    if (!SP_IS_SHAPE(item))//Bulia's suggestion.  Allow all shapes
-        return true;
+    out("    /** text %s */\n", id.c_str());
+    out("    function %s() : Text {\n",id.c_str());
+    out("        Text {\n");
+
+    SPStyle  *style = SP_OBJECT_STYLE(text);
+
+    if (style->text_decoration.set) {
+	if (style->text_decoration.overline)
+	    out("            overline : true\n");
+	if (style->text_decoration.underline)
+	    out("            underline : true\n");
+	if (style->text_decoration.line_through)
+	    out("            strikethrough : true\n");
+    }
+    if (style->text_align.set) {
+	if (style->text_align.value == SP_CSS_TEXT_ALIGN_LEFT ||
+		style->text_align.value == SP_CSS_TEXT_ALIGN_START) 
+	    out("            textAlignment : TextAlignment.LEFT\n");
+	else if (style->text_align.value == SP_CSS_TEXT_ALIGN_RIGHT ||
+		      style->text_align.value == SP_CSS_TEXT_ALIGN_END)
+	    out("            textAlignment : TextAlignment.RIGHT\n");
+	else if (style->text_align.value == SP_CSS_TEXT_ALIGN_CENTER)
+	    out("            textAlignment : TextAlignment.CENTER\n");
+	else if (style->text_align.value == SP_CSS_TEXT_ALIGN_JUSTIFY)
+	    out("            textAlignment : TextAlignment.JUSTIFY\n"); 
+    }
+    out("            font : Font {\n");
+    if (style->font_size.set)
+	out("                size : %.3f\n", style->font_size.computed);
+    if (style->text->font_family.set) {
+        char fullname[32];
+        int  len;
+        sprintf(fullname,"%s", style->text->font_family.value);
+        len = strlen(fullname);
+        if (style->font_stretch.set) {
+            if (style->font_stretch.value == SP_CSS_FONT_STRETCH_ULTRA_CONDENSED)
+                sprintf(fullname+len," UltraCondensed");
+            else if (style->font_stretch.value == SP_CSS_FONT_STRETCH_EXTRA_CONDENSED)
+                sprintf(fullname+len," ExtraCondensed");
+            else if (style->font_stretch.value == SP_CSS_FONT_STRETCH_CONDENSED)
+                sprintf(fullname+len," Condensed");
+            else if (style->font_stretch.value == SP_CSS_FONT_STRETCH_SEMI_CONDENSED)
+                sprintf(fullname+len," SemiCondensed");
+            else if (style->font_stretch.value == SP_CSS_FONT_STRETCH_NORMAL)
+                ;
+            else if (style->font_stretch.value ==  SP_CSS_FONT_STRETCH_SEMI_EXPANDED)
+                sprintf(fullname+len," SemiExpanded");
+            else if (style->font_stretch.value == SP_CSS_FONT_STRETCH_EXPANDED)
+                sprintf(fullname+len," Expanded");
+            else if (style->font_stretch.value == SP_CSS_FONT_STRETCH_EXTRA_EXPANDED)
+                sprintf(fullname+len," ExtraExpanded");
+            else if (style->font_stretch.value == SP_CSS_FONT_STRETCH_ULTRA_EXPANDED)
+                sprintf(fullname+len," UltraExpanded");
+            else if (style->font_stretch.value == SP_CSS_FONT_STRETCH_NARROWER)
+                sprintf(fullname+len," Narrower");
+            else if (style->font_stretch.value == SP_CSS_FONT_STRETCH_WIDER)
+                sprintf(fullname+len," Wider");
+        }
 
-    SPShape *shape = SP_SHAPE(item);
-    SPCurve *curve = shape->curve;
-    if (curve->is_empty())
-        return true;
+        len = strlen(fullname);
+        if (style->font_weight.set) {
+            if (style->font_weight.value >= SP_CSS_FONT_WEIGHT_BOLD)
+                sprintf(fullname+len," Bold");
+        }
 
-    nrShapes++;
+        len = strlen(fullname);
+        if (style->font_style.set) {
+            if (style->font_style.value == SP_CSS_FONT_STYLE_ITALIC)
+                sprintf(fullname+len," Italic");
+            else if (style->font_style.value == SP_CSS_FONT_STYLE_OBLIQUE)
+                sprintf(fullname+len," Oblique");
+        }
+	out("                name : \"%s\"\n", fullname);
+    }
+    out("            }\n");
 
-    out("        SVGPath \n");
-    out("        {\n");
-    out("        id: \"%s\"\n", id.c_str());
 
     /**
      * Output the style information
      */
-    if (!doStyle(SP_OBJECT_STYLE(shape)))
+    if (!doStyle(style))
         return false;
-
-    // convert the path to only lineto's and cubic curveto's:
-    Geom::Scale yflip(1.0, -1.0);
-    Geom::Matrix tf = sp_item_i2d_affine(item) * yflip;
-    Geom::PathVector pathv = pathv_to_linear_and_cubic_beziers( curve->get_pathvector() * tf );
-    
-    //Count the NR_CURVETOs/LINETOs (including closing line segment)
-    nrNodes = 0;
-    for(Geom::PathVector::const_iterator it = pathv.begin(); it != pathv.end(); ++it) {
-        nrNodes += (*it).size();
-        if (it->closed())
-            nrNodes += 1;
+   
+    //Inkscape::XML::Node *node = SP_OBJECT(text)->repr;
+    char const *posX = sp_object_getAttribute(text, "x", NULL); //node->attribute("x")
+    char const *posY = sp_object_getAttribute(text, "y", NULL); //node->attribute("y");
+    if (posX)
+        out("            x: %s\n", posX);
+    if (posY)
+        out("            y: %s\n", posY);
+    Inkscape::Text::Layout const *layout = te_get_layout(text);
+    Glib::ustring content = sp_te_get_string_multiline(text, layout->begin(), layout->end());
+    out("            content : \"%s\"\n", content.c_str());
+
+    // build transformation matrix:
+    Geom::Matrix const tm(sp_item_i2doc_affine(text)); // <- _c[0],_c[1],_c[2],_c[3],_c[4],_c[5]
+    if ( !tm.isIdentity() ) {
+        Geom::Point pX = tm.xAxis();          // <- _c[0], _c[1]
+        Geom::Point pY = tm.yAxis();          // <- _c[2], _c[3]
+        Geom::Point pZ = tm.translation();    // <- _c[4], _c[5]
+        out("            transforms : Transform.affine(%.3f,%.3f,%.3f,%.3f,%.3f,%.3f)\n",
+                 pX[0],pX[1],pY[0],pY[1],pZ[0],pZ[1]);
     }
 
-    char *dataStr = sp_svg_write_path(pathv);
-    out("        content: \"%s\"\n", dataStr);
-    free(dataStr);
-
-    Geom::Rect cminmax( pathv.front().initialPoint(), pathv.front().initialPoint() ); 
-
-    /**
-     * Get the Min and Max X and Y extends for the Path. 
-     * ....For all Subpaths in the <path>
-     */	     
-    for (Geom::PathVector::const_iterator pit = pathv.begin(); pit != pathv.end(); ++pit)
-        {
-        cminmax.expandTo(pit->front().initialPoint());
-        /**
-         * For all segments in the subpath
-         */		         
-        for (Geom::Path::const_iterator cit = pit->begin(); cit != pit->end_closed(); ++cit)
-            {
-            cminmax.expandTo(cit->finalPoint());
-            }
-        }
-
-    out("        },\n");
-
-    double cminx = cminmax.min()[X];
-    double cmaxx = cminmax.max()[X];
-    double cminy = cminmax.min()[Y];
-    double cmaxy = cminmax.max()[Y];
-
-    if (cminx < minx)
-        minx = cminx;
-    if (cmaxx > maxx)
-        maxx = cmaxx;
-    if (cminy < miny)
-        miny = cminy;
-    if (cmaxy > maxy)
-        maxy = cmaxy;
-
+    out("        };\n    }\n");
     return true;
 }
 
 
-
-#endif  /* #if o */
-
-
-
 /**
  *  Output the tree data to buffer
  */
-bool JavaFXOutput::doTreeRecursive(SPDocument *doc, SPObject *obj)
+bool JavaFXOutput::processEffect(SPObject *obj)
 {
-    /**
-     * Check the type of node and process
-     */
-    String id;
-    if (!obj->id)
-        {
-        char buf[16];
-        sprintf(buf, "id%d", idindex++);
-        id = buf;
-        }
-    else
-        {
-        id = obj->id;
-        }
-    if (SP_IS_ITEM(obj))
-        {
-        SPItem *item = SP_ITEM(obj);
-        if (!doCurve(item, id))
-            return false;
-        }
-    else if (SP_IS_GRADIENT(obj))
-        {
-        SPGradient *grad = SP_GRADIENT(obj);
-        if (!doGradient(grad, id))
-            return false;
-        }
+    if (SP_IS_GAUSSIANBLUR(obj)) {
+        SPGaussianBlur *blur = SP_GAUSSIANBLUR(obj);
+        double radius = 2.0 * blur->stdDeviation.getNumber();
+        if (radius >= 64.0)
+            radius = 64.0;
+        if (radius <= 1.0)
+            radius = 1.0;
+        out("            effect: GaussianBlur { radius : %.3f }\n", radius);
+    }
 
-    /**
-     * Descend into children
-     */	     
     for (SPObject *child = obj->firstChild() ; child ; child = child->next)
-        {
-		if (!doTreeRecursive(doc, child))
+    {
+		if (!processEffect(child))
 		    return false;
-		}
+    }
 
     return true;
 }
 
 
-/**
- *  Output the curve data to buffer
- */
-bool JavaFXOutput::doTree(SPDocument *doc)
-{
-
-    double bignum = 1000000.0;
-    minx  =  bignum;
-    maxx  = -bignum;
-    miny  =  bignum;
-    maxy  = -bignum;
-
-    if (!doTreeRecursive(doc, doc->root))
-        return false;
-
-    return true;
-
-}
 
-
-bool JavaFXOutput::doBody(SPDocument *doc, SPObject *obj)
+void JavaFXOutput::writeBody()
 {
-    /**
-     * Check the type of node and process
-     */
-    String id;
-    if (!obj->id)
-        {
-        char buf[16];
-        sprintf(buf, "id%d", idindex++);
-        id = buf;
-        }
-    else
-        {
-        id = obj->id;
-        }
-
-    if (SP_IS_ITEM(obj)) {
-        SPItem *item = SP_ITEM(obj);
-        //### Get the Shape
-        if (SP_IS_SHAPE(item)) {//Bulia's suggestion.  Allow all shapes
-            SPShape *shape = SP_SHAPE(item);
-            SPCurve *curve = shape->curve;
-            if (!curve->is_empty())
-                out("               %s(),\n", id.c_str());
-        }
-    }
-    else if (SP_IS_GRADIENT(obj)) {
-        //TODO: what to do with Gradient within body?????
-        //SPGradient *grad = SP_GRADIENT(reprobj);
-        //if (!doGradient(grad, id))
-        //    return false;
+    std::vector<Glib::ustring>::iterator i;
+    for (i = shapes.begin(); i != shapes.end(); i++) {
+        out("               %s(),\n", (*i).c_str());
     }
-
-    /**
-     * Descend into children
-     */
-    for (SPObject *child = obj->firstChild() ; child ; child = child->next)
-        {
-		if (!doBody(doc, child))
-		    return false;
-		}
-
-    return true;
 }
 
 
@@ -810,6 +949,19 @@
  */
 void JavaFXOutput::reset()
 {
+    std::map<Glib::ustring, SPGradientPtr>::iterator ig;
+    for (ig = gradients.begin(); ig != gradients.end(); ig++) {
+        ig->second = NULL;
+    }
+    gradients.clear();
+
+    std::map<Glib::ustring, SPFilterPtr>::iterator ie;
+    for (ie = effects.begin(); ie != effects.end(); ie++) {
+        ie->second = NULL;
+    }
+    effects.clear();
+    shapes.clear();
+
     nrNodes    = 0;
     nrShapes   = 0;
     idindex    = 0;
@@ -819,6 +971,86 @@
 }
 
 
+/**
+ *  Output the tree data to buffer
+ */
+bool JavaFXOutput::traverseTree(Inkscape::XML::Node *node)
+{
+    /**
+     * Check the type of node and process
+     */
+    Glib::ustring id;
+    SPObject *obj = NULL;
+    Glib::ustring nodeName = node->name();
+    char const *cid = node->attribute("id"); 
+
+    if (!cid)
+        goto recursion;
+
+    // Convert SVG id to "valid" JavaFX id
+    id  = sanatize(cid);
+    obj = SP_ACTIVE_DOCUMENT->getObjectByRepr(node);
+    if (!obj)
+        goto recursion;
+
+    if (SP_IS_RECT(obj)) {
+        SPRect *item = SP_RECT(obj);
+        if (!doRect(item, id))
+            return false;
+        shapes.push_back(id);
+    }
+    else if (SP_IS_CIRCLE(obj)) {
+        SPCircle *item = SP_CIRCLE(obj);
+        if (!doCircle(item, id))
+            return false;
+        shapes.push_back(id);
+    }
+    else if (SP_IS_ELLIPSE(obj)) {
+        SPEllipse *item = SP_ELLIPSE(obj);
+        if (!doEllipse(item, id))
+            return false;
+        shapes.push_back(id);
+    }
+    else if (SP_IS_IMAGE(obj)) {
+        SPImage *image = SP_IMAGE(obj);
+        if (!doImage(image, id))
+            return false;
+        shapes.push_back(id);
+    }
+    else if (SP_IS_TEXT(obj)) {
+        SPText *text = SP_TEXT(obj);
+        if (!doText(text, id))
+            return false;
+        shapes.push_back(id);
+    }
+    else if (SP_IS_GRADIENT(obj)) {
+        SPGradient *grad = SP_GRADIENT(obj);
+        gradients[id] = grad;
+    }
+    else if (SP_IS_FILTER(obj)) {
+        SPFilter *filter = SP_FILTER(obj);
+        effects[id] = filter;
+    }       
+    else if (SP_IS_ITEM(obj)) {
+        SPItem *item = SP_ITEM(obj);
+        if (!doCurve(item, id))
+            return false;
+        if (SP_IS_SHAPE(obj))
+	    shapes.push_back(id);
+    }
+
+recursion:
+	     
+    for (Inkscape::XML::Node *child = node->firstChild(); child; child = child->next())
+    {
+        if (!traverseTree(child))
+            return false;
+    }
+
+    return true;
+}
+
+
 
 /**
  * Saves the <paths> of an Inkscape SVG file as JavaFX spline definitions
@@ -833,32 +1065,27 @@
     if (pos > 0)
         name = name.substr(0, pos);
 
-
-    //###### SAVE IN JAVAFX FORMAT TO BUFFER
-    //# Lets do the curves first, to get the stats
-
-    if (!doTree(doc))
+    //g_message("native file:%s\n", uri);
+    documentUri = URI(uri);
+    if (!traverseTree(doc->rroot))
         return false;
+
     String curveBuf = outbuf;
     outbuf.clear();
 
-    if (!doHeader())
+    if (!doHeader(doc))
         return false;
 
     outbuf.append(curveBuf);
 
-#ifdef JAVAFX_SDK_1_0
-    out("   override function create(): Node {\n");
-#else
-    out("   public function create(): Node {\n");
-#endif
-    out("       Group {\n");
-    out("           content: [\n");
+    out("    override function create(): Node {\n");
+    out("        Group {\n");
+    out("            content: [\n");
     idindex    = 0;
 
-    doBody(doc, doc->root);
+    writeBody();
 
-    if (!doTail())
+    if (!doTail(doc))
         return false;
 
 
@@ -866,15 +1093,15 @@
     //###### WRITE TO FILE
     FILE *f = Inkscape::IO::fopen_utf8name(uri, "w");
     if (!f)
-        {
+    {
         err("Could open JavaFX file '%s' for writing", uri);
         return false;
-        }
+    }
 
     for (String::iterator iter = outbuf.begin() ; iter!=outbuf.end(); iter++)
-        {
+    {
         fputc(*iter, f);
-        }
+    }
         
     fclose(f);
     
@@ -948,7 +1175,6 @@
 
 
 
-
 
 }  // namespace Internal
 }  // namespace Extension
diff -Naur inkscape2/src/extension/internal/javafx-out.h inkscape/src/extension/internal/javafx-out.h
--- inkscape2/src/extension/internal/javafx-out.h	2009-02-12 10:39:35.000000000 +0100
+++ inkscape/src/extension/internal/javafx-out.h	2009-02-10 10:35:03.000000000 +0100
@@ -15,10 +15,26 @@
 #ifndef EXTENSION_INTERNAL_JAVAFX_OUT_H
 #define EXTENSION_INTERNAL_JAVAFX_OUT_H
 
+#include <dom/dom.h>
+#include <dom/io/stringstream.h>
+#include <dom/uri.h>
+
 #include <glib.h>
 #include "extension/implementation/implementation.h"
 #include <document.h>
 #include <sp-gradient.h>
+#include <sp-filter.h>
+#include <sp-gaussian-blur.h>
+#include <sp-rect.h>
+#include <sp-ellipse.h>
+#include <sp-image.h>
+#include <sp-text.h>
+
+#include <string>
+#include <map>
+
+#include <dom/util/ziptool.h>
+#include <dom/io/domstream.h>
 
 namespace Inkscape
 {
@@ -27,7 +43,10 @@
 namespace Internal
 {
 
+// Use the same structures as in odf.h
 
+typedef org::w3c::dom::URI URI;
+typedef org::w3c::dom::io::Writer Writer;
 
 /**
  * Output the current svg document in JavaFX format.
@@ -37,68 +56,70 @@
  */ 
 class JavaFXOutput : public Inkscape::Extension::Implementation::Implementation
 {
-
-
 public:
 
-    /**
-     * Our internal String definition
-     */
     typedef Glib::ustring String;
-
+    typedef SPGradient*   SPGradientPtr;
+    typedef SPFilter*     SPFilterPtr;
 
     /**
      * Check whether we can actually output using this module
      */
-	virtual bool check (Inkscape::Extension::Extension * module);
+    virtual bool check (Inkscape::Extension::Extension * module);
 
     /**
      * API call to perform the output to a file
      */
-	virtual void save (Inkscape::Extension::Output *mod,
-	           SPDocument *doc, const gchar *uri);
+    virtual void save (Inkscape::Extension::Output *mod, SPDocument *doc, const gchar *uri);
 
     /**
      * Inkscape runtime startup call.
      */
-	static void init(void);
+    static void init(void);
 	
     /**
      * Reset variables to initial state
      */
-	void reset();
+    void reset();
 	
 private:
 
+    URI documentUri;
+
+    std::map<String, SPGradientPtr> gradients;     // Gradient table
+    std::map<String, SPFilterPtr>   effects;       // Filter effect's table
+    std::vector<String> shapes;                    // shapes consisting a scene
     //output class name
     String name;
-
     //For formatted output
-	String outbuf;   //main output buffer
-	String foutbuf;  //header function buffer
-
+    String outbuf;   //main output buffer
+    String foutbuf;  //header function buffer
 
-	/**
-	 * Format text to our output buffer
-	 */
-	void out(const char *fmt, ...) G_GNUC_PRINTF(2,3);
 
-	/**
-	 * Format text to our function output buffer
-	 */
-	void fout(const char *fmt, ...) G_GNUC_PRINTF(2,3);
+    /**
+     * Format text to our output buffer
+     */
+    void out(const char *fmt, ...) G_GNUC_PRINTF(2,3);
 
-	//Output the parts of the file
+    /**
+     * Format text to our function output buffer
+     */
+    void fout(const char *fmt, ...) G_GNUC_PRINTF(2,3);
 
     /**
      * Output the file header
      */
-	bool doHeader();
+    bool doHeader(SPDocument *doc);
 
     /**
      *  Output gradient information to the buffer
      */
-    bool doGradient(SPGradient *grad, const String &id);
+    bool processGradient(SPGradient *grad);
+
+    /**
+     *  Output filter information to the buffer
+     */
+    bool processFilter(SPFilter *filter);
 
     /**
      *  Output an element's style attribute
@@ -108,23 +129,29 @@
     /**
      * Output the SVG document's curve data as JavaFX geometry types
      */
-    bool doCurve(SPItem *item, const String &id);
-    bool doTreeRecursive(SPDocument *doc, SPObject *obj);
-    bool doTree(SPDocument *doc);
+    bool doRect(SPRect *item,       const String &id);
+    bool doCircle(SPCircle *item,   const String &id);
+    bool doEllipse(SPEllipse *item, const String &id);
+    bool doCurve(SPItem *item,      const String &id);
+    bool doImage(SPImage *image,    const String &id);
+    bool doText(SPText *text,       const String &id);
+
+    bool processEffect(SPObject *obj);
+    bool traverseTree(Inkscape::XML::Node *node);
 
-    bool doBody(SPDocument *doc, SPObject *obj);
+    void writeBody();
 
     /**
      * Output the file footer
      */
-	bool doTail();
+    bool doTail(SPDocument *doc);
 
 
 
     /**
      * Actual method to save document
      */
-	bool saveDocument(SPDocument *doc, const gchar *uri);
+    bool saveDocument(SPDocument *doc, const gchar *uri);
 
     //For statistics
     int nrNodes;
@@ -136,13 +163,10 @@
     double miny;
     double maxx;
     double maxy;
-    
-
 };
 
 
 
-
 }  // namespace Internal
 }  // namespace Extension
 }  // namespace Inkscape
diff -Naur inkscape2/src/extension/internal/Makefile_insert inkscape/src/extension/internal/Makefile_insert
--- inkscape2/src/extension/internal/Makefile_insert	2009-02-12 10:39:35.000000000 +0100
+++ inkscape/src/extension/internal/Makefile_insert	2009-02-10 10:35:03.000000000 +0100
@@ -110,6 +110,8 @@
 	extension/internal/cairo-renderer-pdf-out.cpp	\
 	extension/internal/cairo-png-out.h \
 	extension/internal/cairo-png-out.cpp \
+	extension/internal/javafx-fxz.cpp	\
+	extension/internal/javafx-fxz.h	\
 	extension/internal/javafx-out.cpp	\
 	extension/internal/javafx-out.h	\
 	extension/internal/gdkpixbuf-input.h	\
